<?php
/**
 * Plugin Acces restreints Giseh 
 */

if (!defined("_ECRIRE_INC_VERSION")) return;


/**
 * Modifier les en-tetes
 *
 * @param int $n
 * @return int
 */
function ciar_image_ecrire_tag_finir($tableau=array()){
    $filtrage_vignettes = false;
    
    if (isset($tableau['data'])){

        // filtrage des vignettes (le parametrage par fichier est prioritaire) ?
        if (isset($GLOBALS['ciconfig']['ciar_protec_pj_et_vignettes_par_filtre'])
                AND $GLOBALS['ciconfig']['ciar_protec_pj_et_vignettes_par_filtre']=='oui'){
                $filtrage_vignettes = true;
        } else {
                if (isset($GLOBALS['meta']['ciar'])) {
                        $ciar_config = @unserialize($GLOBALS['meta']['ciar']);
                        if (isset($ciar_config['filtre_vignettes'])
                            AND $ciar_config['filtre_vignettes']=='oui')
                            $filtrage_vignettes = true;
                }
        }
        
        
        // si filtrage des pieces jointes
        if ($filtrage_vignettes){
            $tag = $tableau['data'];
            $src = extraire_attribut($tag,'src');
            $fichier = '';
            $taille = '';
            $nom = '';
            $extension = '';
            $id_document = 0;

            if ($src){
                // cas de l'espace prive
                if (substr($src,0,3)=='../')
                    $src = substr($src,3);
                        
                // enlever le timestamp eventuel
                $src = preg_replace(',[?][0-9]+$,','',$src);
                
                // SPIP postfixe le nom avec un md5 du path
                // exemple : local/cache-vignettes/L150xH82/debit_video-9d721.png
                if (substr($src,0,22)=='local/cache-vignettes/'){
                    $f = substr($src,22);
                    list($taille,$fichier) = explode('/', $f);
                    $nom = substr($fichier,0,-10);
                    $extension = substr($fichier,-3);
                    $fichier = $extension.'/'.$nom.'.'.$extension;
                    
                    $nom_et_ext1 = $nom.'.'.$extension;
                    if ($extension=='jpg'){
                        $nom_et_ext2 = $nom.'.png';
                        $nom_et_ext3 = $nom.'.gif';
                    } elseif ($extension=='png'){
                        $nom_et_ext2 = $nom.'.jpg';
                        $nom_et_ext3 = $nom.'.gif';
                    } else {
                        $nom_et_ext2 = $nom.'.jpg';
                        $nom_et_ext3 = $nom.'.png';
                    }
                    
                    // un logo d'article, ..., peut avoir une copie reduite dans cache-vignettes
                    if ($GLOBALS['spip_version_branche']>=4) {
                        $ci_dir_logos = _DIR_IMG . "logo/";
                    } else {    
                        $ci_dir_logos = _DIR_LOGOS;
                    }
                    
                    if (@file_exists($d = ($ci_dir_logos . $nom_et_ext1)) 
                            OR @file_exists($d = ($ci_dir_logos . $nom_et_ext2))
                            OR @file_exists($d = ($ci_dir_logos . $nom_et_ext3))) {
                        // inutile de chercher id_document pour un logo d'article, ...
                    } else {
                            $where = sql_in("fichier", array(
                            substr($nom_et_ext1,-3).'/'.$nom_et_ext1,
                            substr($nom_et_ext2,-3).'/'.$nom_et_ext2,
                            substr($nom_et_ext3,-3).'/'.$nom_et_ext3
                            ));
                            $id_document = intval(sql_getfetsel("id_document", "spip_documents", $where, '', '', '0,1'));
                    }

                    include_spip('inc/securiser_action');
                    include_spip('inc/filtres');

                    // cette action doit etre publique !
                    $url = generer_url_action('acceder_vignette',
                                    'arg='.$id_document.'/'.$taille
                                    . '&cle=' . calculer_cle_action($id_document.'/'.$taille.','.$f)
                                    . '&file=' . rawurlencode($f)
                                    ,true,true);
                    
                    $tableau['data'] = inserer_attribut($tag,'src',$url);

                }
            }
        }
    }
	
    return $tableau;	
}

?>