<?php
/**
 * Plugin cilien
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/presentation');
include_spip('inc/actions');
include_spip('inc/cilien');

function exec_ciliengerer(){

	if (!autoriser('configurer', 'configuration')) {
		include_spip('inc/minipres');
		echo minipres();
	} else {
		$commencer_page = charger_fonction('commencer_page', 'inc');
		echo $commencer_page(_T('cilien:recenser_afficher_liens'), "configuration", "configuration");
		
		if ($GLOBALS['spip_version_branche']<3) {
			echo "<br />\n";
			echo gros_titre(_T('cilien:recenser_afficher_liens'),'', false);
		}
		
		echo debut_gauche("",true);
		echo debut_droite("",true);

                echo '<div class="formulaire_spip formulaire_signature ajax">';
                echo '<h3 class="titrem">'._T('cilien:recenser_afficher_liens').'</h3>';
			
		echo cilien_liste_tranches();

		echo '</div>';
		
		echo fin_gauche(), fin_page();
	}
}


function cilien_liste_tranches() {
	$traiter_auto = '';
	$traiter_manuel = false;
	$recensement_vide = true;
        $texte = '';
        $return = '';

	// si demande explicite lancer un traitement
	if (_request('tache') AND _request('tache')=='recenser'){
		$traiter_auto = 'grandpas'; // grand pas
	} else {
		// si pas de demande explicite
		// lancer un traitement uniquement si avancement < 100 (et avancement <> 0)
		$avancements = cilien_avancement();
		foreach ($avancements AS $objet=>$avancement)
			if 	($avancement<100 AND $avancement>0)
				$traiter_auto = 'pas'; // un pas normal
	}

	if ($traiter_auto)
		cilien_traite_tranche($traiter_auto);
	
	$avancements = cilien_avancement();

	foreach ($avancements AS $objet=>$avancement){
		$texte .= "<tr><td>".$objet."</td><td>".round($avancement,2)." %</td></tr>\n";
		if ($avancement<100)
			$traiter_manuel = true;
		if ($avancement>0)
			$recensement_vide = false;
                
	}
	
    if ($texte) {
    	if ($traiter_manuel){
                // Avertissement en cas de recensement incomplet
                $return .= '<div class="notice">';
                $return .= "<p align='center'><b>"._T('avis_attention')."</b></p><P align='justify'>";
                $return .= _T('cilien:texte_recenser_liens_pasok');
                $return .= "</p>";
                $return .= '</div>';
    	}

		$return .= debut_cadre_relief("", true, "", _T('cilien:recenser_liens'));
		
		if ($traiter_manuel){
			$return .= "\n<p style='text-align: justify;'>"._T('cilien:texte_avancement_recensement')."</p>";
		} else {		
			if ($traiter_auto)
				$return .= "\n<p style='text-align: justify;'>"._T('cilien:texte_recenser_liens_okauto')."</p>";
			else
				$return .= "\n<p style='text-align: justify;'>"._T('cilien:texte_recenser_liens_ok')."</p>";
		}
		$return .= '<table summary="'._T('cilien:enregistrements_traites').'" cellspacing="0" cellpadding="2" style="width: 100%; border: 0px none;" class="arial2">
                <caption>'._T('cilien:enregistrements_traites').'</caption>                
                <thead>    
		<tr style="background-color:#eee;">
		<th style="width: 30%;">'._T('cilien:objet').'</th><th style="width: 30%;">'._T('cilien:enregistrements_traites').'</th>
		</tr>
                </thead>
                <tbody>'
	    . $texte
		.'</tbody></table>';
			
		if ($traiter_manuel){
			$return .= '<div style="text-align: right"><a href="'.generer_url_ecrire("ciliengerer","tache=recenser").'"><input type="submit" value="'._T('cilien:recenser_liens').'"></a></div>';
$return .= '<br/>';
$return .= '<div style="text-align: right"><a href="'.generer_action_auteur('cilien_recenser','').'"><input type="submit" value="'._T('cilien:recenser_liens_auto').'"></a></div>';
                }
                
		$return .= fin_cadre_relief(true);
		
		$return .= debut_cadre_relief("", true, "", _T('cilien:afficher_liens'));
		if ($traiter_manuel){
			$return .= "\n<p style='text-align: justify;'>"._T('cilien:texte_afficher_liens_pasok')."</p>";
		} else {
			$return .= "\n<p style='text-align: justify;'>"._T('cilien:texte_afficher_liens_ok')."</p>";
			$return .= '<div style="text-align: right"><a href="'.generer_url_public('cilien').'"><input type="submit" value="'._T('cilien:afficher_liens').'"></a></div>';
		}
		$return .= fin_cadre_relief(true);

                
                if (!$recensement_vide){
                    $return .= debut_cadre_relief("", true, "", _T('cilien:remplacer_liens'));
                    if ($traiter_manuel){
                        $return .= "\n<p style='text-align: justify;'>"._T('cilien:texte_remplacer_liens_pasok')."</p>";
                    } else {
                        $return .= "\n<p style='text-align: justify;'>"._T('cilien:texte_remplacer_liens_ok')."</p>";
                        $return .= '<div style="text-align: right"><a href="'.generer_url_ecrire('cilien_remplacer').'">[ '._T('cilien:remplacer_liens').' ]</a></div>';
                    }                
                    $return .= fin_cadre_relief(true);
                }
                
                
                if (!$recensement_vide){
                    $return .= debut_cadre_relief("", true, "", _T('cilien:vider_recensement'));
                    $return .= "\n<p style='text-align: justify;'>"._T('cilien:texte_vider_recensement')."</p>";
                    $return .= '<div style="text-align: right"><a href="'.generer_url_action('cilien_vider').'">[ '._T('cilien:vider_recensement').' ]</a></div>';
                    $return .= fin_cadre_relief(true);
                }
    }

	return $return;  
}	


?>