<?php
/**
 * Plugin cilien
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/cilien');

/**
 * Fonction qui declenche le recensement d'une tranche
 *
 * @param string $redirect Redirection apres
 * @return bool
 */
function inc_cilien_recenser_dist($redirect = '',$avancement_articles=0) {
    include_spip('inc/autoriser');
    $texte = '';

    if (!autoriser('configurer', 'configuration')) {
        include_spip('inc/minipres');
        echo minipres();
    } else {
        $pas = 250;
        if (_request('step')) {
            $timeout = ini_get('max_execution_time');
            
            // valeur par defaut si on a pas reussi a lire le max_execution_time
            if (!$timeout)
                $timeout = 30;

            // prendre une marge de securite
            if ($timeout>=30)
                $timeout = 10;
            else
                $timeout = $timeout / 2;

        } else {
            $timeout = 2;
        }
        
        include_spip('inc/minipres');
       	if (function_exists('ini_set')){
            @ini_set("zlib.output_compression", "0"); // pour permettre l'affichage au fur et a mesure
        }

        $titre = _T('cilien:recensement_en_cours') . " (" . intval($avancement_articles) . " %) ";
        $balise_img = chercher_filtre('balise_img');
        $titre .= $balise_img(chemin_image('searching.gif'));
        
        
        // au premier coup on ne fait rien sauf afficher l'ecran
        if (_request('step')) {
            cilien_traite_tranche('', $pas, $timeout);
        }
        
        echo(install_debut_html($titre));
        // script de rechargement auto sur timeout
        echo http_script("window.setTimeout('location.href=\"" . $redirect . "\";'," . ($timeout * 1000) . ")");

        echo '<br/>'._T('cilien:attendre').'</div>';
        
        echo '<br/><div id="progressbar" style="width:100%; background-color:white; border:1px solid black; height:25px;">';
        echo '<div id="indicator" style="text-align:center; font-weight:bold; width:'.intval($avancement_articles).'%; background-color:#cedd80;height:25px;">';
        echo intval($avancement_articles).'%</div></div>';
                
        echo '<br/><div style="text-align: right"><a href="'.generer_url_ecrire("ciliengerer").'">'._T('icone_retour').'</a></div>';
        
        echo(install_fin_html());
        ob_end_flush();
        flush();

        return true;
    }
}
