<?php
/**
 * Plugin CINOTIF
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/actions');
include_spip('inc/editer');


function formulaires_cinotif_remplacer_url_charger_dist(){

	$valeurs = array();
	
	if (!autoriser('configurer', 'configuration'))
		return;

	$valeurs['ciedit'] = true;

	return $valeurs;
}


function formulaires_cinotif_remplacer_url_verifier_dist(){
        $erreurs = array();

	if (_request('urlinitiale')){
            $urlinitiale = cinotif_supprimer_protocole(_request('urlinitiale'));

            if (!_request('urlfuture')){
		$erreurs['urlfuture'] = _T('info_obligatoire');
            } else {
                $urlfuture = cinotif_supprimer_protocole(_request('urlfuture'));
                if (!cinotif_verifier_url($urlinitiale))
                    $erreurs['urlinitiale'] =  _T('cinotif:valeur_incorrecte');
                elseif (!cinotif_verifier_url($urlfuture))
                    $erreurs['urlfuture'] =  _T('cinotif:valeur_incorrecte');
                elseif (sql_countsel("spip_cinotif_evenements", "url_multisite=".sql_quote($urlinitiale))==0)
                    $erreurs['urlinitiale'] =  _T('cinotif:url_existe_pas');
            }
        } else {
            $erreurs['urlinitiale'] =  _T('info_obligatoire');
        }

	return $erreurs;
}


function formulaires_cinotif_remplacer_url_traiter_dist(){
        $res = array();

        // remplacer
	if (_request('urlinitiale') AND _request('urlfuture')){
            $urlinitiale = cinotif_supprimer_protocole(_request('urlinitiale'));
            $urlfuture = cinotif_supprimer_protocole(_request('urlfuture'));
            
            $result = sql_select("id_evenement", "spip_cinotif_evenements", "url_multisite=".sql_quote($urlinitiale));
            while ($row = sql_fetch($result)) {
                sql_updateq("spip_cinotif_evenements", array("url_multisite"=>$urlfuture), "id_evenement=".$row['id_evenement']);
            }
        }
        
        $res['message_ok'] = _T('remplacement_fait');
            
	return $res;	
}

function cinotif_verifier_url($url){
    $return = false;
    
    // Ajouter http:// si necessaire
    if (!tester_url_absolue($url)) {
            $url = 'http://' . $url;
    } elseif (strncmp($url, "//", 2) == 0) {
            $url = 'http:' . $url;
    }
    
    // Enlever les caracteres illegaux
    $safe_url = filter_var($url, FILTER_SANITIZE_URL);
    
    if ($safe_url == $url) {
        // Verifier l'url
        if (!filter_var($safe_url, FILTER_VALIDATE_URL) === false)
            $return = true;
    }
    return $return;
}

function cinotif_supprimer_protocole($url){
    $search = array("http://","https://");
    return str_replace($search,"",$url);
}

?>