<?php
/**
 * Plugin redacteur restreint
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

function cirr_ciautoriser($param) {
	$faire = $param['faire'];
	$type = $param['type'];
	$id = $param['id'];
	$qui = $param['qui'];
	$opt = $param['opt'];
	$cifonction = $type.'_'.$faire;


	// Autoriser a publier dans la rubrique
	if ($cifonction=='rubrique_publierdans') {
		// avec l'operateur 'AND' mettre true par defaut
		$autoriser = true;

		// les redacteurs restreints (et admin restreints)
		// ne doivent voir que leurs rubriques
		if (!$id) {
			// mettre imperativement true
			// sinon on n'a plus le bouton pour creer une rubrique, etc. 
			$autoriser = true;
		} else {
			if (in_array($qui['statut'], array('0minirezo', '1comite'))	
				&& ($qui['restreint'] AND $id AND !in_array($id, $qui['restreint'])))
					$autoriser = false;
		}
	
		// utilisation l'operateur 'AND' pour retrecir ce droit 
		$param['autorisations'][] = array('autoriser' => $autoriser, 'operateur' => 'AND');

	
	// Autoriser a voir la rubrique
	} elseif ($cifonction=='rubrique_voir') {
		// avec l'operateur 'AND' mettre true par defaut
		$autoriser = true;
		
		if (!$id) {
			// mettre imperativement true
			// sinon on n'a plus le bouton pour creer une rubrique, etc. 
			$autoriser = true;
		} else {
			// les redacteurs restreints (et admin restreints)
			// ne doivent voir que leurs rubriques
			if (in_array($qui['statut'], array('0minirezo', '1comite'))	
				&& ($qui['restreint'] AND $id AND !in_array($id, $qui['restreint'])))
					$autoriser = false;
		}

		// utilisation l'operateur 'AND' pour retrecir ce droit 
		$param['autorisations'][] = array('autoriser' => $autoriser, 'operateur' => 'AND');


	// Autoriser a voir l'article, la breve, le site reference
	} elseif (in_array($cifonction, array('article_voir','breve_voir','site_voir'))) {
		// avec l'operateur 'AND' mettre true par defaut
		$autoriser = true;
		
		if (!$id) {
                    $autoriser = false;

                    // Dans SPIP 3, autoriser_article_voir peut etre appelee sans $id, mais avec un $opt['statut'] pour tester
                    // la liste des statuts autorises en fonction de $qui['statut']
                    if (isset($opt['statut']))
                        $autoriser = true;
                    
		} else {
			// les redacteurs restreints (et admin restreints)
			// ne doivent voir que les articles de leurs rubriques
			if ($cifonction=='article_voir')
				$row = sql_fetsel('id_rubrique', 'spip_articles',"id_article=".intval($id),'','','');
			elseif ($cifonction=='breve_voir')
				$row = sql_fetsel('id_rubrique', 'spip_breves',"id_breve=".intval($id),'','','');
			elseif ($cifonction=='site_voir')
				$row = sql_fetsel('id_rubrique', 'spip_syndic',"id_syndic=".intval($id),'','','');

                        if ($row){
                                $id_rubrique = $row['id_rubrique'];
                                if (in_array($qui['statut'], array('0minirezo', '1comite'))	
                                        && ($qui['restreint'] AND $id_rubrique AND !in_array($id_rubrique, $qui['restreint']))){
                                                $autoriser = false;
                                }
                        }
		}

		// utilisation l'operateur 'AND' pour retrecir ce droit 
		$param['autorisations'][] = array('autoriser' => $autoriser, 'operateur' => 'AND');
		
	// Autoriser a modifier un document
	// Pour eviter qu'un document non publie puisse etre modifie par tout le monde
	} elseif ($cifonction=='document_modifier') {
		$autoriser = cirr_autorise_document_modifier($faire, $type, $id, $qui, $opt);
		// utilisation l'operateur 'AND' pour retrecir ce droit 
		$param['autorisations'][] = array('autoriser' => $autoriser, 'operateur' => 'AND');		
	}
	
	return $param;	
}

function cirr_autorise_document_modifier($faire, $type, $id, $qui, $opt){
	static $m = array();

	$q=$qui['id_auteur'];
	if (isset($m[$q][$id]))
		return $m[$q][$id];
	
	$s = sql_getfetsel("id_document", "spip_documents", "id_document=".intval($id));
	// les admins ont le droit de modifier tous les documents existants
	if ($qui['statut'] == '0minirezo'
	AND !$qui['restreint'])
		return is_string($s)?true:false;

	if (!defined('_CIRR_ANTI_HACK') OR _CIRR_ANTI_HACK!='oui'){
		if (!isset($m[$q][$id])) {
			// un document non publie peut etre modifie par tout le monde (... ?)
			if ($s AND $s!=='publie' AND ($qui['id_auteur'] > 0))
				$m[$q][$id] = true;
		}
	}
		
	if (!isset($m[$q][$id])) {
		$interdit = false;

		$s = sql_select("id_objet,objet", "spip_documents_liens", "id_document=".intval($id));
		while ($t = sql_fetch($s)) {
			if (!autoriser('modifier', $t['objet'], $t['id_objet'], $qui, $opt)) {
				$interdit = true;
				break;
			}
		}

		$m[$q][$id] = ($interdit?false:true);
	}

	return $m[$q][$id];
}

?>