<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */


function ciwidget_ciautoriser($param) {
	$faire = $param['faire'];
	$type = $param['type'];
	$id = $param['id'];
	$qui = $param['qui'];
	$opt = $param['opt'];
	$cifonction = $type.'_'.$faire;
		
	// Autoriser a modifier un document
	// Pour eviter qu'un document non publie puisse etre modifie par tout le monde
	if ($cifonction=='document_modifier') {
		$autoriser = ciwidget_autorise_document_modifier($faire, $type, $id, $qui, $opt);
		// utilisation l'operateur 'AND' pour retrecir ce droit 
		$param['autorisations'][] = array('autoriser' => $autoriser, 'operateur' => 'AND');		
	}
	// Autoriser a supprimer une vignette liee a un document qui est lie a un widget
	if ($cifonction=='document_supprimer') {
		$autoriser = ciwidget_autorise_document_supprimer($faire, $type, $id, $qui, $opt);
		// utilisation l'operateur 'OR' pour elargir ce droit 
		$param['autorisations'][] = array('autoriser' => $autoriser, 'operateur' => 'OR');		
	}
	
	return $param;	
}


function ciwidget_autorise_document_modifier($faire, $type, $id, $qui, $opt){
	static $m = array();

	$q=$qui['id_auteur'];
	if (isset($m[$q][$id]))
		return $m[$q][$id];
		
	if (!isset($m[$q][$id])) {
		$interdit = false;
		if (sql_countsel("spip_documents_liens", "id_document=".intval($id)." AND objet='ciwidget'")>0){
                        $interdit = true;
                }
		$m[$q][$id] = ($interdit?false:true);
	}

	return $m[$q][$id];
}

function ciwidget_autorise_document_supprimer($faire, $type, $id, $qui, $opt){
	static $m = array();

	$q=$qui['id_auteur'];
	if (isset($m[$q][$id]))
		return $m[$q][$id];
		
	if (!isset($m[$q][$id])) {
		$interdit = true;
                $id_document_avec_vignette = sql_getfetsel('id_document', 'spip_documents', 'id_vignette=' . intval($id));
		if ($id_document_avec_vignette AND sql_countsel("spip_documents_liens", "id_document=".intval($id_document_avec_vignette)." AND objet='ciwidget'")>0){
                        $interdit = false;
                }
		$m[$q][$id] = ($interdit?false:true);
	}

	return $m[$q][$id];
}


?>