<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');

function formulaires_ciwidget_chiffre_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet))
		return false;

        $valeurs = array('titre'=>'','unite'=>'','descriptif'=>'','chiffre_zoom'=>'','unite_zoom'=>'');
        
        $id_widget = intval($id_widget);
	if ($id_widget>0) {
		$result = sql_select("*", "spip_ciwidget", "id_widget=$id_widget");
		while ($row = sql_fetch($result)) { 
			$valeurs = $row;
		}
        
                // anti hack
                if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!='chiffre'){
                    return false;
                }
                
                // unserialize le champ contenu
                if (isset($valeurs['contenu'])){
                    $contenu = unserialize($valeurs['contenu']);
                    $valeurs['contenu'] = '';
                    if ($contenu AND is_array($contenu)){
                        $valeurs = array_merge($valeurs,$contenu);
                    }
                }
	}
        
        $valeurs['retour_objet'] = ciwidget_retour_vers_objet($objet, $id_objet);

	return $valeurs;
}

function formulaires_ciwidget_chiffre_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $erreurs = array();
        
	$titre = _request('titre');	
	if (!$titre){
		$erreurs['titre'] = _T('info_obligatoire');
        }
        
	return $erreurs;
}

function formulaires_ciwidget_chiffre_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $id_widget = intval($id_widget);

        $c = array();
	foreach (array('titre', 'descriptif') as $champ){
		$c[$champ] = _request($champ);
        }
        
        $unite = _request('unite');
        
        $chiffre_zoom = _request('chiffre_zoom');
        if (intval($chiffre_zoom)>0 AND intval($chiffre_zoom)>=50 AND intval($chiffre_zoom)<=150){
            $chiffre_zoom = _request('chiffre_zoom');
        } else {
            $chiffre_zoom = 100;
        }

        $unite_zoom = _request('unite_zoom');
        if (intval($unite_zoom)>0 AND intval($unite_zoom)>=50 AND intval($unite_zoom)<=150){
            $unite_zoom = _request('unite_zoom');
        } else {
            $unite_zoom = 100;
        }
        
        $c['contenu'] = serialize(array('unite'=>$unite,'chiffre_zoom'=>$chiffre_zoom,'unite_zoom'=>$unite_zoom));
        
        $type_widget = 'chiffre';
        $c['type_widget'] = $type_widget;
        $c['objet'] = $objet;
        $c['id_objet'] = $id_objet;

	if ($id_widget>0) {
            // modifier
            sql_updateq("spip_ciwidget", $c, "id_widget=$id_widget");
        } else {
            // ajouter et lier
            $id_widget = sql_insertq('spip_ciwidget', $c);
        }
    
        $res = ciwidget_retour_formulaire($objet,$id_objet,$type_widget,$retour);

	return $res;
}

function ciwidget_choix_zoom($nom_element='',$valeur_element=''){
    $return = '';
    $selected = '';
    $disabled = '';
    
    if (!$valeur_element){
        $valeur_element = '100';
    }
    
    // tableau des valeurs
    $tableau_valeurs = array('50','60','70','80','90','100','110','120','130','140','150');
    // Parcours du tableau
    $return .= '<select name="'.$nom_element.'" '.$disabled.'>'."\n";
    foreach($tableau_valeurs as $valeur){
        if($valeur == $valeur_element){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $valeur .'"'. $selected . '>'. $valeur .'%</option>'."\n";
    }
    $return .= '</select>'."\n";
    
    return $return;
}


?>