<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/ciwidget_tmp');
include_spip('inc/ciwidget_graphique');
include_spip('inc/ciwidget_importer');


function formulaires_ciwidget_graphique5_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
	if (!$id_widget_tmp){
		return false;
        }

        $valeurs = ciwidget_valeurs_tmp($id_widget,$id_widget_tmp,'graphique');
        
        // securite
	if (!isset($valeurs['objet']) OR !isset($valeurs['id_objet']) OR !isset($valeurs['id_auteur']) 
                OR !autoriser('modifier',$valeurs['objet'],$valeurs['id_objet'])
                OR $valeurs['id_auteur']!=$GLOBALS['visiteur_session']['id_auteur']){
		return false;
        }

        $champs_prerequis = array(
            'type',
            'titre'
            );
        foreach ($champs_prerequis AS $champ){
            if (!isset($valeurs[$champ]) OR !$valeurs[$champ]){
                return false;
            }
        }
        
	$valeurs['url'] = '';
        
        $valeurs['retour_objet'] = ciwidget_retour_tmp_vers_objet($id_widget_tmp,$objet,$id_objet,$valeurs);
        $valeurs['ci_action'] = self('&', true);
        
	return $valeurs;
}

function formulaires_ciwidget_graphique5_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        $erreurs = array();
        $tableau_extensions = array('xlsx','csv');
        
        if (isset($_POST['suivant'])){
            $path = _request('url');
            
            if (!tester_url_absolue($path)) {
                    return _T('medias:erreur_chemin_distant', array('nom' => $path));
            } else {
                $extension = ciwidget_extension_tableau_distant($path,$tableau_extensions);
                if (!in_array(strtolower($extension),$tableau_extensions) ){
                    $erreurs['url'] = _T('medias:erreur_upload_type_interdit',array('nom' => $path));
                }
            }
        }
        
	return $erreurs;
}

function formulaires_ciwidget_graphique5_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        refuser_traiter_formulaire_ajax();    

        include_spip('inc/distant');
        
        $type_widget = 'graphique';
        $c = array();
        $contenu_nouveau = array();
        $texte = '';
        $tableau_extensions = array('xlsx','csv');
        
        $path = _request('url');

        $extension = ciwidget_extension_tableau_distant($path,$tableau_extensions);
        
        $result = recuperer_url($path);
        if (isset($result['page'])){
            $texte = $result['page'];
        }
        
        if ($extension=='xlsx'){
            $c['donnees'] = ciwidget_lire_xlsx('',$texte);
            
        } elseif ($extension=='csv'){
            $c['donnees'] = ciwidget_lire_csv('',$texte);
        }
        
        $id_widget_tmp = ciwidget_maj_tmp($id_widget,$id_widget_tmp,$c,$contenu_nouveau);

        $res = ciwidget_retour_formulaire_etape($objet,$id_objet,$id_widget,$id_widget_tmp,$type_widget,ciwidget_numform());

	return $res;
}

?>