<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/ciwidget_tmp');
include_spip('inc/ciwidget_graphique');
include_spip('inc/filtres_boites');

function formulaires_ciwidget_graphique99_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
	if (!$id_widget AND !$id_widget_tmp AND !autoriser('modifier',$objet,$id_objet)){
		return false;
        }

        // verifier si les donnees temporaires existent deja pour ce widget (quelque soit l'auteur)
        $modif_en_cours = '';
        $date_creation_tmp_existant = '';
        $id_auteur_tmp_existant = '';
        if ($id_widget AND !$id_widget_tmp){
            $result = sql_select("date_creation_tmp,id_auteur", "spip_ciwidget_tmp", "id_widget=".intval($id_widget),"","date_creation_tmp");
            while ($row = sql_fetch($result)) { 
                    $date_creation_tmp_existant = $row['date_creation_tmp'];
                    $id_auteur_existant = $row['id_auteur'];
            }
        }
        
        // parametres : identifiants, type de widget, valeurs par defaut (mode creation du widget et premier affichage du formulaire)
        $valeurs = ciwidget_valeurs_tmp($id_widget,$id_widget_tmp,'graphique');

        if (isset($valeurs['yAxes_unite'])){
            $valeurs['_yAxes_unite'] = $valeurs['yAxes_unite'];            
        } else {
            $valeurs['_yAxes_unite'] = '';
        }
        
        // securite
        if (intval($id_widget_tmp) > 0){
            if (!isset($valeurs['objet']) OR !isset($valeurs['id_objet']) OR !isset($valeurs['id_auteur']) 
                    OR !autoriser('modifier',$valeurs['objet'],$valeurs['id_objet'])
                    OR $valeurs['id_auteur']!=$GLOBALS['visiteur_session']['id_auteur']){
                    return false;
            }
        }
        
        // adresse de retour
        $valeurs['retour_objet'] = ciwidget_retour_tmp_vers_objet($id_widget_tmp,$objet,$id_objet,$valeurs);
        
        // verifier si le contenu du tmp a ete modifie depuis sa creation
        $valeurs['notice'] = '';            
        $acces_concurrent = '';
        if ($id_widget_tmp AND ciwidget_tmp_modifie($id_widget_tmp)){
            $valeurs['notice'] = 'oui';
            if(!$id_widget AND isset($valeurs['id_widget'])){
                $id_widget = $valeurs['id_widget'];
            }

            // verifier si les donnees permanentes ont ete modifiees entre temps (acces concurrent)
            $maj_initiale = '';
            if (isset($valeurs['maj'])){
                $maj_initiale = $valeurs['maj'];
            }
            $maj_actuelle = sql_getfetsel("maj", "spip_ciwidget", "id_widget=".$id_widget);
            if ($maj_initiale!=$maj_actuelle){
                $acces_concurrent = 'oui';
            }
        }
        
        // signaler en cours d'edition le cas echeant
        if ($date_creation_tmp_existant AND $id_auteur_existant AND isset($valeurs['maj'])){
            if (strtotime($date_creation_tmp_existant) >= strtotime($valeurs['maj'])
                AND time() < (86400 + strtotime($date_creation_tmp_existant)) ){
                $nom_auteur_tmp_existant = sql_getfetsel('nom', 'spip_auteurs', 'id_auteur='.intval($id_auteur_existant));

		// format lie a la chaine de langue
		$tableau_modif_en_cours = array(
			'nom_auteur_modif' => $nom_auteur_tmp_existant,
			'date_diff' => ceil((time() - strtotime($date_creation_tmp_existant)) / 60)
		);
                if (intval($id_auteur_existant) == intval($GLOBALS['visiteur_session']['id_auteur'])){
                    // sauf si F5
                    if (isset($_SERVER['HTTP_REFERER'])){
//                        $modif_en_cours = _T('ciwidget:info_meme_auteur_edite', $tableau_modif_en_cours);
                    }
                } else {
                    $modif_en_cours = _T('ciwidget:info_autre_auteur_edite', $tableau_modif_en_cours);                
                }    
            }
        }
        
        $valeurs['modif_en_cours'] = $modif_en_cours;            
        $valeurs['acces_concurrent'] = $acces_concurrent;            
        
	return $valeurs;
}

function formulaires_ciwidget_graphique99_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
	return array();
}

function formulaires_ciwidget_graphique99_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $id_widget_tmp = 0, $retour = '') {
        refuser_traiter_formulaire_ajax();    
    
        $type_widget = 'graphique';
        $res = array();
        $res['message_ok'] = 'Ok';
        $res['redirect'] = ciwidget_retour_tmp_vers_objet($id_widget_tmp,$objet,$id_objet);
        
        if (_request('reset')) {
            if (!$id_widget_tmp){
                $id_widget_tmp = _request('id_widget_tmp');
            }
            if ($id_widget_tmp){
                sql_updateq("spip_ciwidget_tmp", array('date_creation_tmp'=>'0000-00-00 00:00:00'), "id_widget_tmp=$id_widget_tmp");
            }
            
        } else {
        
            // verifier si le contenu du tmp a ete modifie depuis sa creation
            if (ciwidget_tmp_modifie($id_widget_tmp)){
                // A mettre imperativement a la fin
                // Verser les donnees temporaires dans les donnees persistantes)
                $resultat = ciwidget_verser_tmp_dans_widget($id_widget_tmp,$type_widget,$id_widget);

                // memoriser l'image du graphique
                ciwidget_enregistrer_image($id_widget);
                ciwidget_enregistrer_csv($id_widget);
                
            } else {
                if (!$id_widget_tmp){
                    $id_widget_tmp = _request('id_widget_tmp');
                }
                if ($id_widget_tmp){
                    sql_updateq("spip_ciwidget_tmp", array('date_creation_tmp'=>'0000-00-00 00:00:00'), "id_widget_tmp=$id_widget_tmp");
                }
            }

        }
        
	return $res;
}

?>