<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/doc_commun');
include_spip('formulaires/joindre_document');


function formulaires_ciwidget_infographie_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet)){
		return false;
        }
        
        $type_widget = 'infographie';
        
        $valeurs = ciwidget_document_charger($objet, $id_objet, $type_widget, $id_widget, $retour);
        
        if (ciwidget_utiliser_bigup()) {
          $valeurs['_bigup_rechercher_fichiers'] = true;
        }
      
        return $valeurs;
}

function formulaires_ciwidget_infographie_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
    $erreurs = array();
    $erreurs_upload = array();
    $id_widget = intval($id_widget);
    $type_format = 'image';
        
    if ($objet AND $id_objet){
        
        if ($id_widget){
            
            $titre = _request('titre');	
            if (!$titre){
                    $erreurs['titre'] = _T('info_obligatoire');
            }
            
            $descriptif = _request('descriptif');	
            if (!$descriptif){
                    $erreurs['descriptif'] = _T('info_obligatoire');
            }

            // ne pas autoriser le remplacement par un document distant
            if (_request('joindre_distant')) {
                    $erreurs['url'] = _T('ciwidget:distant_non_autorise');
            }
        }

        if (_request('joindre_upload')) {
            $verifier = charger_fonction('verifier', 'formulaires/joindre_document');
            if ($id_widget){
                // verifier l'upload si on a demande a changer le document
                if ($contenu_actuel = sql_getfetsel("contenu", "spip_ciwidget", "id_widget=$id_widget")){
                    $contenu_actuel_unserialize = unserialize($contenu_actuel);
                    if (isset($contenu_actuel_unserialize['id_document'])){
                        $id_document = intval($contenu_actuel_unserialize['id_document']);
                        $erreurs_upload = $verifier($id_document);
                    }
                }
            } else {
                $erreurs_upload = $verifier('new', $id_objet, $objet);
            }
            
            if (!$erreurs_upload) {
                $post = isset($_FILES) ? $_FILES : $GLOBALS['HTTP_POST_FILES'];
                $erreur_format = ciwidget_verifier_upload_formats_autorises($post,$type_format);
                if ($erreur_format){
                    $erreurs['fichier_upload'] = $erreur_format;
                }
            } else {
                $erreurs = array_merge($erreurs, $erreurs_upload);
            }
        }
    }
    
    return $erreurs;
}

function formulaires_ciwidget_infographie_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
    
        $type_widget = 'infographie';
        
        return ciwidget_document_traiter($objet, $id_objet, $type_widget, $id_widget, $retour);
}


function ciwidget_infographie_explication($arg=''){
    $tableau_formats_image_autorises = ciwidget_formats_image_autorises();
    $formats_image_autorises = implode(', ',$tableau_formats_image_autorises);

    $return = '<div>'._T('ciwidget:widget_image_format', array('format_image_autorise'=>$formats_image_autorises)).'</div>';
    
    return $return;
}


?>