<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/ciwidget_inc_meta');

function formulaires_ciwidget_rss_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet))
		return false;

        $valeurs_par_defaut = ciwidget_lire_meta_widget('rss');
        
        $valeurs = array('titre'=>'','descriptif'=>'','id_syndic'=>'',
            'nb_article'=>$valeurs_par_defaut['nb_article_defaut'],
            'affiche_descriptif'=>$valeurs_par_defaut['affiche_descriptif_defaut'],
            'affiche_date_article'=>$valeurs_par_defaut['affiche_date_article_defaut']);
        
        $id_widget = intval($id_widget);
	if ($id_widget>0) {
		$result = sql_select("*", "spip_ciwidget", "id_widget=$id_widget");
		while ($row = sql_fetch($result)) { 
			$valeurs = $row;
		}
        
                // anti hack
                if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!='rss'){
                    return false;
                }
                
                // unserialize le champ contenu
                if (isset($valeurs['contenu'])){
                    $contenu = unserialize($valeurs['contenu']);
                    $valeurs['contenu'] = '';
                    if ($contenu AND is_array($contenu)){
                        $valeurs = array_merge($valeurs,$contenu);
                    }
                }
	}

        $valeurs['retour_objet'] = ciwidget_retour_vers_objet($objet, $id_objet);

	return $valeurs;
}

function formulaires_ciwidget_rss_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $erreurs = array();

	$id_syndic = intval(_request('id_syndic'));	
	if (!$id_syndic){
		$erreurs['id_syndic'] = _T('info_obligatoire');
        } elseif (!sql_countsel("spip_syndic", "id_syndic=".intval($id_syndic)." AND statut='publie' AND syndication='oui'")){
		$erreurs['id_syndic'] = _T('ciwidget:valeur_incorrecte');
        }
        
	$nb_article = intval(_request('nb_article'));	
	if (!$nb_article OR $nb_article>100){
		$erreurs['nb_article'] = _T('ciwidget:valeur_incorrecte');
        }
        
	$affiche_descriptif = _request('affiche_descriptif');	
        if (!in_array($affiche_descriptif, array('oui','non'))){
		$erreurs['affiche_descriptif'] = _T('ciwidget:valeur_incorrecte');
        }
        
	$affiche_date_article = _request('affiche_date_article');	
        if (!in_array($affiche_date_article, array('oui','non'))){
		$erreurs['affiche_date_article'] = _T('ciwidget:valeur_incorrecte');
        }
        
	return $erreurs;
}

function formulaires_ciwidget_rss_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $id_widget = intval($id_widget);
        $c = array();
        
        $id_syndic = intval(_request('id_syndic'));
        $syndic = sql_fetsel('nom_site, descriptif', 'spip_syndic', 'id_syndic=' . intval($id_syndic));
        if ($syndic){
            $c['titre'] = $syndic['nom_site'];
            $c['descriptif'] = $syndic['descriptif'];
        }
	$nb_article = intval(_request('nb_article'));	
	$affiche_descriptif = _request('affiche_descriptif');	
	$affiche_date_article = _request('affiche_date_article');	
        
        $type_widget = 'rss';
        $c['contenu'] = serialize(array('id_syndic'=>$id_syndic,'nb_article'=>$nb_article,
                'affiche_descriptif'=>$affiche_descriptif,
                'affiche_date_article'=>$affiche_date_article));
        $c['type_widget'] = $type_widget;
        $c['objet'] = $objet;
        $c['id_objet'] = $id_objet;

	if ($id_widget>0) {
            // modifier
            sql_updateq("spip_ciwidget", $c, "id_widget=$id_widget");
        } else {
            // ajouter et lier
            $id_widget = sql_insertq('spip_ciwidget', $c);
        }
    
        $res = ciwidget_retour_formulaire($objet,$id_objet,$type_widget,$retour);

	return $res;
}

function ciwidget_choisir_id_syndic($nom_element='',$cle_element='',$disabled=''){
    $return = '';
    $selected = '';
    $disabled_texte = '';
    if ($disabled){
        $disabled_texte = 'disabled="disabled"';
    }
    
    // tableau des valeurs
    $tableau_valeurs = sql_allfetsel("*","spip_syndic","statut='publie' AND syndication='oui'","","nom_site");
    
    // Parcours du tableau
    $return .= '<select name="'.$nom_element.'" id="'.$nom_element.'" '.$disabled_texte.'>';
    if (!$cle_element){
        $return .= "\t".'<option value="" selected="selected">&nbsp;</option>'."\n";
    }
    foreach($tableau_valeurs as $row){
        
        if($row['id_syndic'] == $cle_element){
            $selected = ' selected="selected"';
        } else {
            $selected = '';
        }
        
        // Affichage de la ligne
        $return .= "\t".'<option value="'. $row['id_syndic'] .'"'. $selected . '>'. $row['nom_site'] .'</option>'."\n";
    }
    $return .= '</select>'."\n";

    return $return;
}

?>