<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');

function formulaires_ciwidget_sitereference_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet))
		return false;

        $valeurs = array('titre'=>'','descriptif'=>'','id_syndic'=>'','titre_lien'=>'titre_lien1');
        
        $id_widget = intval($id_widget);
	if ($id_widget>0) {
		$result = sql_select("*", "spip_ciwidget", "id_widget=$id_widget");
		while ($row = sql_fetch($result)) { 
			$valeurs = $row;
		}
        
                // anti hack
                if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!='sitereference'){
                    return false;
                }
                
                // unserialize le champ contenu
                if (isset($valeurs['contenu'])){
                    $contenu = unserialize($valeurs['contenu']);
                    $valeurs['contenu'] = '';
                    if ($contenu AND is_array($contenu)){
                        $valeurs = array_merge($valeurs,$contenu);
                    }
                }
	}

        $valeurs['retour_objet'] = ciwidget_retour_vers_objet($objet, $id_objet);

	return $valeurs;
}

function formulaires_ciwidget_sitereference_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $erreurs = array();
        
	$id_syndic = intval(_request('id_syndic'));	
	if (!$id_syndic){
		$erreurs['id_syndic'] = _T('info_obligatoire');
        } elseif (!sql_countsel("spip_syndic", "id_syndic=".intval($id_syndic)." AND statut='publie'")){
		$erreurs['id_syndic'] = _T('ciwidget:valeur_incorrecte');
        }
        
	return $erreurs;
}

function formulaires_ciwidget_sitereference_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
        $id_widget = intval($id_widget);
        $c = array();
        
        $id_syndic = intval(_request('id_syndic'));
        $syndic = sql_fetsel('nom_site, descriptif', 'spip_syndic', 'id_syndic=' . intval($id_syndic));
        if ($syndic){
            $c['titre'] = $syndic['nom_site'];
            $c['descriptif'] = $syndic['descriptif'];
        }

        if (in_array(_request('titre_lien'),array('titre_lien1','titre_lien2','titre_lien3'))){
            $titre_lien = _request('titre_lien');	
        } else {
            $titre_lien = '';	
        }
        
        $type_widget = 'sitereference';
        $c['contenu'] = serialize(array('id_syndic'=>$id_syndic,'titre_lien'=>$titre_lien));
        $c['type_widget'] = $type_widget;
        $c['objet'] = $objet;
        $c['id_objet'] = $id_objet;

	if ($id_widget>0) {
            // modifier
            sql_updateq("spip_ciwidget", $c, "id_widget=$id_widget");
        } else {
            // ajouter et lier
            $id_widget = sql_insertq('spip_ciwidget', $c);
        }
    
        $res = ciwidget_retour_formulaire($objet,$id_objet,$type_widget,$retour);

	return $res;
}

?>