<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');
include_spip('inc/video_commun');
include_spip('inc/doc_commun');
include_spip('formulaires/joindre_document');


function formulaires_ciwidget_video_charger_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
	if (!autoriser('modifier',$objet,$id_objet)){
		return false;
        }
        
        $type_widget = 'video';
        
        // $champs_supplementaires (memorises dans le widget)
        $champs_supplementaires_defaut = array('loop'=>'false', 'autoplay'=>'false');
        $champs_supplementaires_renseignes = $champs_supplementaires_defaut;
        
        $valeurs = ciwidget_document_charger($objet, $id_objet, $type_widget, $id_widget, $retour, $champs_supplementaires_defaut, $champs_supplementaires_renseignes);
        
        if (ciwidget_utiliser_bigup()) {
          $valeurs['_bigup_rechercher_fichiers'] = true;
        }
      
        return $valeurs;
}

function formulaires_ciwidget_video_verifier_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
    $erreurs = array();
    $erreurs_upload = array();
    $id_widget = intval($id_widget);
    $type_format = 'video';
        
    if ($objet AND $id_objet){
        
        if ($id_widget){
            
            $titre = _request('titre');	
            if (!$titre){
                    $erreurs['titre'] = _T('info_obligatoire');
            }

            if (ciwidget_erreur_largeur(_request('largeur'))){
                $erreurs['largeur'] = ciwidget_erreur_largeur(_request('largeur'));
            }

            if (ciwidget_erreur_hauteur(_request('hauteur'))){
                $erreurs['hauteur'] = ciwidget_erreur_hauteur(_request('hauteur'));
            }	

            if (_request('duree_editable')=='oui' AND ciwidget_erreur_duree(_request('duree'))){
                $erreurs['duree'] = ciwidget_erreur_duree(_request('duree'));
            }	

            $loop = _request('loop');
            if (!in_array($loop, array('true','false'))){
                    $erreurs['loop'] = _T('ciwidget:valeur_incorrecte');
            }
            $autoplay = _request('autoplay');
            if (!in_array($autoplay, array('true','false'))){
                    $erreurs['autoplay'] = _T('ciwidget:valeur_incorrecte');
            }
            
            // ne pas autoriser le remplacement par un document distant
            if (_request('joindre_distant')) {
                    $erreurs['url'] = _T('ciwidget:distant_non_autorise');
            }
        }

        if (_request('joindre_upload')) {
            $verifier = charger_fonction('verifier', 'formulaires/joindre_document');
            if ($id_widget){
                // verifier l'upload si on a demande a changer le document
                if ($contenu_actuel = sql_getfetsel("contenu", "spip_ciwidget", "id_widget=$id_widget")){
                    $contenu_actuel_unserialize = unserialize($contenu_actuel);
                    if (isset($contenu_actuel_unserialize['id_document'])){
                        $id_document = intval($contenu_actuel_unserialize['id_document']);
                        $erreurs_upload = $verifier($id_document);
                    }
                }
            } else {
                $erreurs_upload = $verifier('new', $id_objet, $objet);
            }
            
            if (!$erreurs_upload) {
                $post = isset($_FILES) ? $_FILES : $GLOBALS['HTTP_POST_FILES'];
                $erreur_format = ciwidget_verifier_upload_formats_autorises($post,$type_format);
                if ($erreur_format){
                    $erreurs['fichier_upload'] = $erreur_format;
                } else {
                    $erreur_debit = ciwidget_verifier_upload_debit_max_video($post);
                    if ($erreur_debit){
                        $erreurs['fichier_upload'] = $erreur_debit;
                    }
                }
            } else {
                $erreurs = array_merge($erreurs, $erreurs_upload);
            }
        }
    }
        
    return $erreurs;
}

function formulaires_ciwidget_video_traiter_dist($objet = '', $id_objet = '', $id_widget = 0, $retour = '') {
    
        $type_widget = 'video';
        
        // $champs_supplementaires (memorises dans le widget)
        $champs_supplementaires_defaut = array('loop'=>'false', 'autoplay'=>'false');
        $champs_supplementaires_renseignes = $champs_supplementaires_defaut;
        
        if ($id_widget){
            $loop = _request('loop');
            if (!in_array($loop, array('true','false'))){
                $loop = 'false';
            }
            $autoplay = _request('autoplay');
            if (!in_array($autoplay, array('true','false'))){
                $autoplay = 'false';
            }
            $champs_supplementaires_renseignes = array('loop'=>$loop, 'autoplay'=>$autoplay);
        }
        
        return ciwidget_document_traiter($objet, $id_objet, $type_widget, $id_widget, $retour, $champs_supplementaires_defaut, $champs_supplementaires_renseignes);
}

?>