<?php
/**
 * Plugin CIWIDGET
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined('_ECRIRE_INC_VERSION')) {
	return;
}

include_spip('inc/widget_commun');    

function ciwidget_imposer_type_galerie($type_galerie=''){
    $return = $type_galerie;
    
    $ci_imposer_type_galerie = ciwidget_lire_meta_cle('galerie','imposer_type_galerie');

    if ($ci_imposer_type_galerie=='oui'){
        $ci_type_galerie_defaut = ciwidget_lire_meta_cle('galerie','type_galerie_defaut');
        if ($ci_type_galerie_defaut){
            $return = $ci_type_galerie_defaut;
        }
    }
    
    return $return;
}

function ciwidget_galerie_vignette_width($largeur=''){
    $return = $largeur;
    
    $ci_vignette_width = ciwidget_lire_meta_cle('galerie','vignette_width');

    if ($ci_vignette_width){
        $return = strval(floatval($ci_vignette_width));
    }
    
    return $return;
}

function ciwidget_galerie_vignette_height($hauteur=''){
    $return = $hauteur;
    
    $ci_vignette_width = ciwidget_lire_meta_cle('galerie','vignette_width');

    if ($ci_vignette_width AND strtolower(substr(trim($ci_vignette_width),-2))=='px'){
        $return = strval(round( floatval($hauteur) * (floatval($ci_vignette_width) / 150) ));
    }
    
    return $return;
}

function ciwidget_galerie_tableau_images($id_widget=0){
    $tableau_images = array();
    
    $id_widget = intval($id_widget);
    if ($id_widget>0) {
        $valeurs = array();
        $objet = '';
        $id_objet = 0;

        $valeurs = ciwidget_valeurs_lues_en_base($id_widget,'galerie');
        
        if (isset($valeurs['objet'])){
            $objet = $valeurs['objet'];
        }
        if (isset($valeurs['id_objet'])){
            $id_objet = $valeurs['id_objet'];
        }

        // anti hack
        if (isset($valeurs['type_widget']) AND $valeurs['type_widget']!='galerie'){
            return array();
        }

        $afficher_certaines_images = 'non';
        if (isset($valeurs['afficher_certaines_images'])){
            $afficher_certaines_images = $valeurs['afficher_certaines_images'];
        }
        if ($afficher_certaines_images == 'oui'){
            if (isset($valeurs['liste_images'])){
                $tableau_images = explode(',', $valeurs['liste_images']);
            }
        } else {
            $result2 = sql_select("id_document", "spip_documents_liens", "id_objet=".$id_objet." AND objet='".$objet."' AND vu='non'");
            while ($row2 = sql_fetch($result2)) { 
                $tableau_images[] = $row2['id_document'];
            }
        }
    }
    
    return $tableau_images;
}

function ciwidget_galerie_script($arg=''){
    static $done = false;
    static $firstarg = 0;
    $return = '';
    $cilang = 'fr';
    if (in_array($GLOBALS['spip_lang'],array('en'))){
            $cilang = $GLOBALS['spip_lang'];
    }
    
    // compatibilite avec un squelette qui contient plusieurs fois la balise #TEXTE du meme objet
    if (!$done OR $firstarg==$arg){
        $done = true;
        $firstarg = $arg;
        $return = '<script src="'.find_in_path("lib/splide/splide.min.js").'"></script>';
        $return .= '<script src="'.find_in_path("_js/cisplide_".$cilang."_min.js").'"></script>';
    }
    
    return $return;
}

function ciwidget_galerie_script_vignette($id_widget){
    $return = '';
    $id_widget = intval($id_widget);

    if ($id_widget>0){
        $vignette_width = floatval(ciwidget_lire_meta_cle('galerie','vignette_width'));
        
$return = "<script>
function widget_galerie_".$id_widget."() {
  var main = new Splide( '#galerie_".$id_widget."_main-carousel', {
    type      : 'fade',
    rewind    : false,
    pagination: false,
    arrowPath: 'm13.5 7.01 13 13m-13 13 13-13',
  } );

  var thumbnails = new Splide( '#galerie_".$id_widget."_thumbnail-carousel', {
    fixedWidth  : ".$vignette_width.",
    gap         : 10,
    arrows    : false,
    rewind      : false,
    pagination  : false,
    
    updateOnMove : true,
    keyboard: false,
    
//    focus      : 'center',
    isNavigation: true,
    breakpoints : {
      600: {
        fixedWidth : 60,
        fixedHeight: 44,
      },
    },
  } );

  main.sync( thumbnails );
  main.mount(window.splide.Extensions);
  thumbnails.mount(window.splide.Extensions);
}

if (window.location.href.indexOf('/ecrire/') != -1){
    widget_galerie_".$id_widget."();
} else {
    document.addEventListener( 'DOMContentLoaded', widget_galerie_".$id_widget.");
}
</script>";    
    }
    return $return;
}


function ciwidget_galerie_script_point($id_widget){
    $return = '';
    $id_widget = intval($id_widget);

    if ($id_widget>0){
        
$return = "<script>
function widget_galerie_".$id_widget."() {
  var main = new Splide( '#galerie_".$id_widget."_main-carousel', {
    type      : 'fade',
    pagination: true,
    rewind    : false,
    keyboard: false,
    slideFocus: false,
    arrowPath: 'm13.5 7.01 13 13m-13 13 13-13',
  } );

  main.mount(window.splide.Extensions);
}

if (window.location.href.indexOf('/ecrire/') != -1){
    widget_galerie_".$id_widget."();
} else {
    document.addEventListener( 'DOMContentLoaded', widget_galerie_".$id_widget.");
}
</script>";    
    }
    return $return;
}


function ciwidget_galerie_script_normal($id_widget){
    $return = '';
    $id_widget = intval($id_widget);

    if ($id_widget>0){
        
$return = "<script>
function widget_galerie_".$id_widget."() {
  var main = new Splide( '#galerie_".$id_widget."_main-carousel', {
    type      : 'fade',
    pagination: false,
    rewind    : false,
    keyboard: false,
    slideFocus: false,
    arrowPath: 'm13.5 7.01 13 13m-13 13 13-13',
  } );

  main.mount(window.splide.Extensions);
}

if (window.location.href.indexOf('/ecrire/') != -1){
    widget_galerie_".$id_widget."();
} else {
    document.addEventListener( 'DOMContentLoaded', widget_galerie_".$id_widget.");
}
</script>";    
    }
    return $return;
}

?>